// Specification file for TASEDITOR_WINDOW class

#define TASEDITOR_WINDOW_TOTAL_ITEMS 43
#define TOOLTIP_TEXT_MAX_LEN 80
#define TOOLTIPS_AUTOPOP_TIMEOUT 30000

#define PATTERNS_MENU_POS 5
#define PATTERNS_MAX_VISIBLE_NAME 50
#define PATTERNMENU_MAX_VISIBLE_NAME PATTERNS_MAX_VISIBLE_NAME + 6		// + "Pattern: "

enum ECONTEXTMENU
{
	CONTEXTMENU_STRAY = 0,
	CONTEXTMENU_SELECTED = 1,
};

class TASEDITOR_WINDOW
{
public:
	TASEDITOR_WINDOW();
	void init();
	void exit();
	void reset();
	void update();

	void ResizeItems();
	void WindowMovedOrResized();

	void UpdateTooltips();

	void UpdateCaption();
	void RedrawTaseditor();

	void UpdateCheckedItems();

	void UpdateRecentProjectsMenu();
	void UpdateRecentProjectsArray(const char* addString);
	void RemoveRecentProject(unsigned int which);
	void LoadRecentProject(int slot);

	void UpdatePatternsMenu();
	void RecheckPatternsMenu();

	void SetTaseditorInput();
	void ClearTaseditorInput();

	HWND hwndTasEditor, hwndFindNote;
	bool TASEditor_focus;
	bool ready_for_resizing;
	int min_width;
	int min_height;

private:
	void CalculateItems();


	HWND hToolTipWnd;
	HMENU hmenu, patterns_menu;
	HICON hTaseditorIcon;

};
